Index: src/sas/sascalc/dataloader/readers/cansas_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision ae69c690bae8eb1cae0c6902dd71755dda9710f8)
+++ src/sas/sascalc/dataloader/readers/cansas_reader.py	(revision e6e89c48e4673e2c76326dc1f6f7b8fd4927d873)
@@ -1,20 +1,9 @@
 import logging
-import numpy as np
 import os
 import sys
 import datetime
 import inspect
-# For saving individual sections of data
-from sas.sascalc.dataloader.data_info import Data1D, Data2D, DataInfo, \
-    plottable_1D, plottable_2D
-from sas.sascalc.dataloader.data_info import Collimation, TransmissionSpectrum, \
-    Detector, Process, Aperture
-from sas.sascalc.dataloader.data_info import \
-    combine_data_info_with_plottable as combine_data
-import sas.sascalc.dataloader.readers.xml_reader as xml_reader
-from sas.sascalc.dataloader.readers.xml_reader import XMLreader
-from sas.sascalc.dataloader.readers.cansas_constants import CansasConstants, CurrentLevel
-from sas.sascalc.dataloader.loader_exceptions import FileContentsException, \
-    DefaultReaderException, DataReaderException
+
+import numpy as np
 
 # The following 2 imports *ARE* used. Do not remove either.
@@ -23,4 +12,16 @@
 
 from lxml import etree
+
+from sas.sascalc.data_util.nxsunit import Converter
+
+# For saving individual sections of data
+from ..data_info import Data1D, Data2D, DataInfo, plottable_1D, plottable_2D, \
+    Collimation, TransmissionSpectrum, Detector, Process, Aperture, \
+    combine_data_info_with_plottable as combine_data
+from ..loader_exceptions import FileContentsException, DefaultReaderException, \
+    DataReaderException
+from . import xml_reader
+from .xml_reader import XMLreader
+from .cansas_constants import CansasConstants, CurrentLevel
 
 logger = logging.getLogger(__name__)
@@ -34,8 +35,4 @@
               "as much of the data as possible.\n\n"
 HAS_CONVERTER = True
-try:
-    from sas.sascalc.data_util.nxsunit import Converter
-except ImportError:
-    HAS_CONVERTER = False
 
 CONSTANTS = CansasConstants()
@@ -163,5 +160,6 @@
                 raise fc_exc
         except Exception as e: # Convert all other exceptions to FileContentsExceptions
-            raise FileContentsException(e.message)
+            raise
+            raise FileContentsException(str(e))
 
 
@@ -632,9 +630,11 @@
                 else:
                     save_in = "current_datainfo"
-                exec "default_unit = self.{0}.{1}".format(save_in, unitname)
-                if local_unit and default_unit and local_unit.lower() != default_unit.lower() \
-                        and local_unit.lower() != "none":
-                    if HAS_CONVERTER == True:
+                default_unit = getattrchain(self, '.'.join((save_in, unitname)))
+                if (local_unit and default_unit
+                        and local_unit.lower() != default_unit.lower()
+                        and local_unit.lower() != "none"):
+                    if HAS_CONVERTER:
                         # Check local units - bad units raise KeyError
+                        #print("loading", tagname, node_value, local_unit, default_unit)
                         data_conv_q = Converter(local_unit)
                         value_unit = default_unit
@@ -654,5 +654,5 @@
                     err_msg += "expecting [{0}]".format(default_unit)
                 value_unit = local_unit
-            except:
+            except Exception:
                 err_msg = "CanSAS reader: unknown error converting "
                 err_msg += "\"{0}\" unit [{1}]"
@@ -717,5 +717,5 @@
         doc, _ = self._to_xml_doc(datainfo)
         # Write the file
-        file_ref = open(filename, 'w')
+        file_ref = open(filename, 'wb')
         if self.encoding is None:
             self.encoding = "UTF-8"
@@ -908,7 +908,7 @@
         point = self.create_element("Idata")
         node.append(point)
-        qx = ','.join([str(datainfo.qx_data[i]) for i in xrange(len(datainfo.qx_data))])
-        qy = ','.join([str(datainfo.qy_data[i]) for i in xrange(len(datainfo.qy_data))])
-        intensity = ','.join([str(datainfo.data[i]) for i in xrange(len(datainfo.data))])
+        qx = ','.join(str(v) for v in datainfo.qx_data)
+        qy = ','.join(str(v) for v in datainfo.qy_data)
+        intensity = ','.join(str(v) for v in datainfo.data)
 
         self.write_node(point, "Qx", qx,
@@ -919,22 +919,17 @@
                         {'unit': datainfo._zunit})
         if datainfo.err_data is not None:
-            err = ','.join([str(datainfo.err_data[i]) for i in
-                            xrange(len(datainfo.err_data))])
+            err = ','.join(str(v) for v in datainfo.err_data)
             self.write_node(point, "Idev", err,
                             {'unit': datainfo._zunit})
         if datainfo.dqy_data is not None:
-            dqy = ','.join([str(datainfo.dqy_data[i]) for i in
-                            xrange(len(datainfo.dqy_data))])
+            dqy = ','.join(str(v) for v in datainfo.dqy_data)
             self.write_node(point, "Qydev", dqy,
                             {'unit': datainfo._yunit})
         if datainfo.dqx_data is not None:
-            dqx = ','.join([str(datainfo.dqx_data[i]) for i in
-                            xrange(len(datainfo.dqx_data))])
+            dqx = ','.join(str(v) for v in datainfo.dqx_data)
             self.write_node(point, "Qxdev", dqx,
                             {'unit': datainfo._xunit})
         if datainfo.mask is not None:
-            mask = ','.join(
-                ["1" if datainfo.mask[i] else "0"
-                 for i in xrange(len(datainfo.mask))])
+            mask = ','.join("1" if v else "0" for v in datainfo.mask)
             self.write_node(point, "Mask", mask)
 
@@ -1280,5 +1275,5 @@
         try:
             value = float(entry.text)
-        except:
+        except ValueError:
             value = None
 
@@ -1289,13 +1284,12 @@
             if units is not None:
                 toks = variable.split('.')
-                local_unit = None
-                exec "local_unit = storage.%s_unit" % toks[0]
+                # TODO: why split() when accessing unit, but not when setting value?
+                local_unit = getattr(storage, toks[0]+"_unit")
                 if local_unit is not None and units.lower() != local_unit.lower():
                     if HAS_CONVERTER == True:
                         try:
                             conv = Converter(units)
-                            exec "storage.%s = %g" % \
-                                (variable, conv(value, units=local_unit))
-                        except:
+                            setattrchain(storage, variable, conv(value, units=local_unit))
+                        except Exception:
                             _, exc_value, _ = sys.exc_info()
                             err_mess = "CanSAS reader: could not convert"
@@ -1306,5 +1300,5 @@
                                 logger.info(err_mess)
                             else:
-                                raise ValueError, err_mess
+                                raise ValueError(err_mess)
                     else:
                         err_mess = "CanSAS reader: unrecognized %s unit [%s];"\
@@ -1315,9 +1309,9 @@
                             logger.info(err_mess)
                         else:
-                            raise ValueError, err_mess
+                            raise ValueError(err_mess)
                 else:
-                    exec "storage.%s = value" % variable
+                    setattrchain(storage, variable, value)
             else:
-                exec "storage.%s = value" % variable
+                setattrchain(storage, variable, value)
 
     # DO NOT REMOVE - used in saving and loading panel states.
@@ -1339,5 +1333,5 @@
         entry = get_content(location, node)
         if entry is not None and entry.text is not None:
-            exec "storage.%s = entry.text.strip()" % variable
+            exec("storage.%s = entry.text.strip()" % variable)
 
 # DO NOT REMOVE Called by outside packages:
@@ -1382,2 +1376,20 @@
         return True
     return False
+
+def getattrchain(obj, chain, default=None):
+    """Like getattr, but the attr may contain multiple parts separated by '.'"""
+    for part in chain.split('.'):
+        if hasattr(obj, part):
+            obj = getattr(obj, part, None)
+        else:
+            return default
+    return obj
+
+def setattrchain(obj, chain, value):
+    """Like setattr, but the attr may contain multiple parts separated by '.'"""
+    parts = list(chain.split('.'))
+    for part in parts[-1]:
+        obj = getattr(obj, part, None)
+        if obj is None:
+            raise ValueError("missing parent object "+part)
+    setattr(obj, value)
Index: src/sas/sascalc/dataloader/readers/cansas_reader_HDF5.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_reader_HDF5.py	(revision c9ecd1b562e38798001341ea1382b347f0cc1af9)
+++ src/sas/sascalc/dataloader/readers/cansas_reader_HDF5.py	(revision 7b50f14eb38e44aca64b1a233e5b996b05f5dc0c)
@@ -9,11 +9,13 @@
 import sys
 
-from sas.sascalc.dataloader.data_info import plottable_1D, plottable_2D,\
+from ..data_info import plottable_1D, plottable_2D,\
     Data1D, Data2D, DataInfo, Process, Aperture, Collimation, \
     TransmissionSpectrum, Detector
-from sas.sascalc.dataloader.data_info import combine_data_info_with_plottable
-from sas.sascalc.dataloader.loader_exceptions import FileContentsException, DefaultReaderException
-from sas.sascalc.dataloader.file_reader_base_class import FileReader
-
+from ..data_info import combine_data_info_with_plottable
+from ..loader_exceptions import FileContentsException, DefaultReaderException
+from ..file_reader_base_class import FileReader, decode
+
+def h5attr(node, key, default=None):
+    return decode(node.attrs.get(key, default))
 
 class Reader(FileReader):
@@ -130,8 +132,7 @@
             # Get all information for the current key
             value = data.get(key)
-            if value.attrs.get(u'canSAS_class') is not None:
-                class_name = value.attrs.get(u'canSAS_class')
-            else:
-                class_name = value.attrs.get(u'NX_class')
+            class_name = h5attr(value, u'canSAS_class')
+            if class_name is None:
+                class_name = h5attr(value, u'NX_class')
             if class_name is not None:
                 class_prog = re.compile(class_name)
@@ -225,4 +226,6 @@
 
                 for data_point in data_set:
+                    if data_point.dtype.char == 'S':
+                        data_point = decode(bytes(data_point))
                     # Top Level Meta Data
                     if key == u'definition':
@@ -231,8 +234,8 @@
                         self.current_datainfo.run.append(data_point)
                         try:
-                            run_name = value.attrs['name']
+                            run_name = h5attr(value, 'name')
                             run_dict = {data_point: run_name}
                             self.current_datainfo.run_name = run_dict
-                        except:
+                        except Exception:
                             pass
                     elif key == u'title':
@@ -576,7 +579,7 @@
         :return: unit for the value passed to the method
         """
-        unit = value.attrs.get(u'units')
+        unit = h5attr(value, u'units')
         if unit is None:
-            unit = value.attrs.get(u'unit')
+            unit = h5attr(value, u'unit')
         # Convert the unit formats
         if unit == "1/A":
Index: src/sas/sascalc/dataloader/readers/danse_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/danse_reader.py	(revision a78a02fe90f1c962f523301685c143a27f11ba7d)
+++ src/sas/sascalc/dataloader/readers/danse_reader.py	(revision af3e9f590874286ad2be3a1e5be489d605e8a9a0)
@@ -14,10 +14,12 @@
 import math
 import os
+import logging
+
 import numpy as np
-import logging
-from sas.sascalc.dataloader.data_info import plottable_2D, DataInfo, Detector
-from sas.sascalc.dataloader.manipulations import reader2D_converter
-from sas.sascalc.dataloader.file_reader_base_class import FileReader
-from sas.sascalc.dataloader.loader_exceptions import FileContentsException, DataReaderException
+
+from ..data_info import plottable_2D, DataInfo, Detector
+from ..manipulations import reader2D_converter
+from ..file_reader_base_class import FileReader
+from ..loader_exceptions import FileContentsException, DataReaderException
 
 logger = logging.getLogger(__name__)
@@ -78,5 +80,5 @@
         data_start_line = 1
         while read_on:
-            line = self.f_open.readline()
+            line = self.nextline()
             data_start_line += 1
             if line.find("DATA:") >= 0:
@@ -112,5 +114,5 @@
             raise FileContentsException(msg)
 
-        for line_num, data_str in enumerate(self.f_open.readlines()):
+        for line_num, data_str in enumerate(self.nextlines()):
             toks = data_str.split()
             try:
Index: src/sas/sascalc/dataloader/readers/red2d_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/red2d_reader.py	(revision 2f85af7145254a68c54575abc23e44599ebef7ae)
+++ src/sas/sascalc/dataloader/readers/red2d_reader.py	(revision c8321cfca1fe64cbabb0c8b781cf5aecc57c211b)
@@ -10,16 +10,14 @@
 ######################################################################
 import os
+import math
+import time
+
 import numpy as np
-import math
-from sas.sascalc.dataloader.data_info import plottable_2D, DataInfo, Detector
-from sas.sascalc.dataloader.file_reader_base_class import FileReader
-from sas.sascalc.dataloader.loader_exceptions import FileContentsException
-
-# Look for unit converter
-has_converter = True
-try:
-    from sas.sascalc.data_util.nxsunit import Converter
-except:
-    has_converter = False
+
+from sas.sascalc.data_util.nxsunit import Converter
+
+from ..data_info import plottable_2D, DataInfo, Detector
+from ..file_reader_base_class import FileReader
+from ..loader_exceptions import FileContentsException
 
 
@@ -31,5 +29,5 @@
     try:
         return float(x_point)
-    except:
+    except Exception:
         return 0
 
@@ -51,5 +49,4 @@
         :param data: data2D
         """
-        import time
         # Write the file
         try:
@@ -72,5 +69,5 @@
     def get_file_contents(self):
         # Read file
-        buf = self.f_open.read()
+        buf = self.readall()
         self.f_open.close()
         # Instantiate data object
@@ -119,31 +116,25 @@
                 try:
                     wavelength = float(line_toks[1])
-                    # Units
-                    if has_converter == True and \
-                    self.current_datainfo.source.wavelength_unit != 'A':
+                    # Wavelength is stored in angstroms; convert if necessary
+                    if self.current_datainfo.source.wavelength_unit != 'A':
                         conv = Converter('A')
                         wavelength = conv(wavelength,
                                           units=self.current_datainfo.source.wavelength_unit)
-                except:
-                    #Not required
-                    pass
-                # Distance in mm
+                except Exception:
+                    pass  # Not required
                 try:
                     distance = float(line_toks[3])
-                    # Units
-                    if has_converter == True and self.current_datainfo.detector[0].distance_unit != 'm':
+                    # Distance is stored in meters; convert if necessary
+                    if self.current_datainfo.detector[0].distance_unit != 'm':
                         conv = Converter('m')
                         distance = conv(distance,
                             units=self.current_datainfo.detector[0].distance_unit)
-                except:
-                    #Not required
-                    pass
-
-                # Distance in meters
+                except Exception:
+                    pass  # Not required
+
                 try:
                     transmission = float(line_toks[4])
-                except:
-                    #Not required
-                    pass
+                except Exception:
+                    pass  # Not required
 
             if line.count("LAMBDA") > 0:
@@ -170,5 +161,5 @@
 
             ## Read and get data.
-            if data_started == True:
+            if data_started:
                 line_toks = line.split()
                 if len(line_toks) == 0:
@@ -178,4 +169,5 @@
                 col_num = len(line_toks)
                 break
+
         # Make numpy array to remove header lines using index
         lines_array = np.array(lines)
@@ -203,5 +195,5 @@
         # Change it(string) into float
         #data_list = map(float,data_list)
-        data_list1 = map(check_point, data_list)
+        data_list1 = list(map(check_point, data_list))
 
         # numpy array form
@@ -211,5 +203,5 @@
         try:
             data_point = data_array.reshape(row_num, col_num).transpose()
-        except:
+        except Exception:
             msg = "red2d_reader can't read this file: Incorrect number of data points provided."
             raise FileContentsException(msg)
@@ -325,7 +317,7 @@
 
         # Units of axes
-        self.current_dataset.xaxis("\\rm{Q_{x}}", 'A^{-1}')
-        self.current_dataset.yaxis("\\rm{Q_{y}}", 'A^{-1}')
-        self.current_dataset.zaxis("\\rm{Intensity}", "cm^{-1}")
+        self.current_dataset.xaxis(r"\rm{Q_{x}}", 'A^{-1}')
+        self.current_dataset.yaxis(r"\rm{Q_{y}}", 'A^{-1}')
+        self.current_dataset.zaxis(r"\rm{Intensity}", "cm^{-1}")
 
         # Store loading process information
Index: src/sas/sascalc/dataloader/readers/sesans_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/sesans_reader.py	(revision be434489a51d7ec8b03d82a7e2d53cb8baa37c83)
+++ src/sas/sascalc/dataloader/readers/sesans_reader.py	(revision 849094a5f7b0f78510cbd819f7325b0940f60cdb)
@@ -6,9 +6,11 @@
     Jurrian Bakker
 """
+import os
+
 import numpy as np
-import os
-from sas.sascalc.dataloader.file_reader_base_class import FileReader
-from sas.sascalc.dataloader.data_info import plottable_1D, DataInfo
-from sas.sascalc.dataloader.loader_exceptions import FileContentsException, DataReaderException
+
+from ..file_reader_base_class import FileReader
+from ..data_info import plottable_1D, DataInfo
+from ..loader_exceptions import FileContentsException, DataReaderException
 
 # Check whether we have a converter available
@@ -42,5 +44,5 @@
         self.output = []
 
-        line = self.f_open.readline()
+        line = self.nextline()
         params = {}
         while not line.startswith("BEGIN_DATA"):
@@ -48,5 +50,5 @@
             if len(terms) >= 2:
                 params[terms[0]] = " ".join(terms[1:])
-            line = self.f_open.readline()
+            line = self.nextline()
         self.params = params
 
@@ -68,5 +70,5 @@
                                "handled by other software.")
 
-        headers = self.f_open.readline().split()
+        headers = self.nextline().split()
 
         self._insist_header(headers, "SpinEchoLength")
Index: src/sas/sascalc/dataloader/readers/tiff_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/tiff_reader.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sascalc/dataloader/readers/tiff_reader.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -2,5 +2,5 @@
 #This software was developed by the University of Tennessee as part of the
 #Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
-#project funded by the US National Science Foundation. 
+#project funded by the US National Science Foundation.
 #See the license text in license.txt
 #copyright 2008, University of Tennessee
@@ -31,9 +31,9 @@
     ## Extension
     ext = ['.tif', '.tiff']
-        
+
     def read(self, filename=None):
         """
         Open and read the data in a file
-        
+
         :param file: path of the file
         """
@@ -44,15 +44,15 @@
         except:
             msg = "tiff_reader: could not load file. Missing Image module."
-            raise RuntimeError, msg
-        
+            raise RuntimeError(msg)
+
         # Instantiate data object
         output = Data2D()
         output.filename = os.path.basename(filename)
-            
+
         # Read in the image
         try:
             im = Image.open(filename)
         except:
-            raise  RuntimeError, "cannot open %s"%(filename)
+            raise  RuntimeError("cannot open %s"%(filename))
         data = im.getdata()
 
@@ -61,5 +61,5 @@
         output.err_data = np.zeros([im.size[0], im.size[1]])
         output.mask = np.ones([im.size[0], im.size[1]], dtype=bool)
-        
+
         # Initialize
         x_vals = []
@@ -69,5 +69,5 @@
         for i_x in range(im.size[0]):
             x_vals.append(i_x)
-            
+
         itot = 0
         for i_y in range(im.size[1]):
@@ -80,5 +80,5 @@
                 logger.error("tiff_reader: had to skip a non-float point")
                 continue
-            
+
             # Get bin number
             if math.fmod(itot, im.size[0]) == 0:
@@ -87,9 +87,9 @@
             else:
                 i_x += 1
-                
+
             output.data[im.size[1] - 1 - i_y][i_x] = value
-            
+
             itot += 1
-                
+
         output.xbins = im.size[0]
         output.ybins = im.size[1]
@@ -102,5 +102,5 @@
         output.ymin = 0
         output.ymax = im.size[0] - 1
-        
+
         # Store loading process information
         output.meta_data['loader'] = self.type_name
Index: src/sas/sascalc/dataloader/readers/xml_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/xml_reader.py	(revision fafe52a82bebe8d8a20bfb820388c964aa3c4b7b)
+++ src/sas/sascalc/dataloader/readers/xml_reader.py	(revision 7b50f14eb38e44aca64b1a233e5b996b05f5dc0c)
@@ -16,7 +16,9 @@
 
 import logging
+
 from lxml import etree
 from lxml.builder import E
-from sas.sascalc.dataloader.file_reader_base_class import FileReader
+
+from ..file_reader_base_class import FileReader, decode
 
 logger = logging.getLogger(__name__)
@@ -151,6 +153,6 @@
         Converts an etree element into a string
         """
-        return etree.tostring(elem, pretty_print=pretty_print, \
-                              encoding=encoding)
+        return decode(etree.tostring(elem, pretty_print=pretty_print,
+                                     encoding=encoding))
 
     def break_processing_instructions(self, string, dic):
Index: src/sas/sascalc/file_converter/c_ext/bsl_loader.c
===================================================================
--- src/sas/sascalc/file_converter/c_ext/bsl_loader.c	(revision 2ab9c432bb247d0039ef9051ec98bfdcdc8a7021)
+++ src/sas/sascalc/file_converter/c_ext/bsl_loader.c	(revision d04ac056c476a91de374975fdb618e1cf1d27ca1)
@@ -1,4 +1,4 @@
 #include <Python.h>
-//#define NPY_NO_DEPRECATED_API NPY_1_7_API_VERSION
+#define NPY_NO_DEPRECATED_API NPY_1_7_API_VERSION
 #include <numpy/arrayobject.h>
 #include <stdio.h>
@@ -44,5 +44,5 @@
 static void CLoader_dealloc(CLoader *self) {
     free(self->params.filename);
-    self->ob_type->tp_free((PyObject *)self);
+    Py_TYPE(self)->tp_free((PyObject *)self);
 }
 
@@ -237,6 +237,7 @@
 
 static PyTypeObject CLoaderType = {
-    PyObject_HEAD_INIT(NULL)
-    0,                         /*ob_size*/
+    //PyObject_HEAD_INIT(NULL)
+    //0,                         /*ob_size*/
+    PyVarObject_HEAD_INIT(NULL, 0)
     "CLoader",             /*tp_name*/
     sizeof(CLoader),             /*tp_basicsize*/
@@ -278,15 +279,68 @@
 };
 
-PyMODINIT_FUNC
-initbsl_loader(void)
-{
-    PyObject *module;
-    module = Py_InitModule("bsl_loader", NULL);
-    import_array();
-
+static PyMethodDef module_methods[] = {
+    {NULL}
+};
+
+/**
+ * Function used to add the model class to a module
+ * @param module: module to add the class to
+ */
+void addCLoader(PyObject *module) {
     if (PyType_Ready(&CLoaderType) < 0)
         return;
 
     Py_INCREF(&CLoaderType);
-    PyModule_AddObject(module, "CLoader", (PyObject *)&CLoaderType);
-}
+    PyModule_AddObject(module, "bsl_loader", (PyObject *)&CLoaderType);
+}
+
+
+#define MODULE_DOC "C module for loading bsl."
+#define MODULE_NAME "bsl_loader"
+#define MODULE_INIT2 initbsl_loader
+#define MODULE_INIT3 PyInit_bsl_loader
+#define MODULE_METHODS module_methods
+
+/* ==== boilerplate python 2/3 interface bootstrap ==== */
+
+
+#if defined(WIN32) && !defined(__MINGW32__)
+    #define DLL_EXPORT __declspec(dllexport)
+#else
+    #define DLL_EXPORT
+#endif
+
+#if PY_MAJOR_VERSION >= 3
+
+  DLL_EXPORT PyMODINIT_FUNC MODULE_INIT3(void)
+  {
+    static struct PyModuleDef moduledef = {
+      PyModuleDef_HEAD_INIT,
+      MODULE_NAME,         /* m_name */
+      MODULE_DOC,          /* m_doc */
+      -1,                  /* m_size */
+      MODULE_METHODS,      /* m_methods */
+      NULL,                /* m_reload */
+      NULL,                /* m_traverse */
+      NULL,                /* m_clear */
+      NULL,                /* m_free */
+    };
+	PyObject* m = PyModule_Create(&moduledef);
+	addCLoader(m);
+	return m;
+  }
+
+#else /* !PY_MAJOR_VERSION >= 3 */
+
+  DLL_EXPORT PyMODINIT_FUNC MODULE_INIT2(void)
+  {
+    PyObject* m = Py_InitModule4(MODULE_NAME,
+		 MODULE_METHODS,
+		 MODULE_DOC,
+		 0,
+		 PYTHON_API_VERSION
+		 );
+	addCLoader(m);
+  }
+
+#endif /* !PY_MAJOR_VERSION >= 3 */
Index: src/sas/sascalc/file_converter/cansas_writer.py
===================================================================
--- src/sas/sascalc/file_converter/cansas_writer.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sascalc/file_converter/cansas_writer.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -32,5 +32,5 @@
         valid_class = all([issubclass(data.__class__, Data1D) for data in frame_data])
         if not valid_class:
-            raise RuntimeError, ("The cansas writer expects an array of "
+            raise RuntimeError("The cansas writer expects an array of "
                 "Data1D instances")
 
Index: src/sas/sascalc/file_converter/nxcansas_writer.py
===================================================================
--- src/sas/sascalc/file_converter/nxcansas_writer.py	(revision 5e9062071eef0080f51c5de4c3cfb3bb129ebab6)
+++ src/sas/sascalc/file_converter/nxcansas_writer.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -166,5 +166,5 @@
             'wavelength_max': 'wavelength_max',
             'wavelength_spread': 'incident_wavelength_spread' }
-        for sasname, nxname in wavelength_keys.iteritems():
+        for sasname, nxname in wavelength_keys.items():
             value = getattr(data_info.source, sasname)
             units = getattr(data_info.source, sasname + '_unit')
Index: src/sas/sascalc/fit/AbstractFitEngine.py
===================================================================
--- src/sas/sascalc/fit/AbstractFitEngine.py	(revision 50fcb09b3ee47cf23c26b90d9c291f41415c0aa5)
+++ src/sas/sascalc/fit/AbstractFitEngine.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -251,5 +251,5 @@
             msg = "FitData1D: invalid error array "
             msg += "%d <> %d" % (np.shape(self.dy), np.size(fx))
-            raise RuntimeError, msg
+            raise RuntimeError(msg)
         return (self.y[self.idx] - fx[self.idx]) / self.dy[self.idx], fx[self.idx]
 
Index: src/sas/sascalc/fit/Loader.py
===================================================================
--- src/sas/sascalc/fit/Loader.py	(revision a1b8fee73528559155793dd74cda07d0c32e9d72)
+++ src/sas/sascalc/fit/Loader.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -18,20 +18,20 @@
         self.dy = dy
         self.filename = None
-        
+
     def set_filename(self, path=None):
         """
-        Store path into a variable.If the user doesn't give 
+        Store path into a variable.If the user doesn't give
         a path as a parameter a pop-up
         window appears to select the file.
-        
+
         :param path: the path given by the user
-        
+
         """
         self.filename = path
-       
+
     def get_filename(self):
         """ return the file's path"""
         return self.filename
-    
+
     def set_values(self):
         """ Store the values loaded from file in local variables"""
@@ -42,5 +42,5 @@
             self.x = []
             self.y = []
-            self.dx = [] 
+            self.dx = []
             self.dy = []
             for line in lines:
@@ -50,5 +50,5 @@
                     y = float(toks[1])
                     dy = float(toks[2])
-                    
+
                     self.x.append(x)
                     self.y.append(y)
@@ -59,13 +59,13 @@
             # Sanity check
             if not len(self.x) == len(self.dx):
-                raise ValueError, "x and dx have different length"
+                raise ValueError("x and dx have different length")
             if not len(self.y) == len(self.dy):
-                raise ValueError, "y and dy have different length"
-            
-            
+                raise ValueError("y and dy have different length")
+
+
     def get_values(self):
         """ Return x, y, dx, dy"""
         return self.x, self.y, self.dx, self.dy
-    
+
     def load_data(self, data):
         """ Return plottable"""
@@ -77,12 +77,11 @@
         #Load its View class
         #plottable.reset_view()
-       
-    
-if __name__ == "__main__": 
+
+
+if __name__ == "__main__":
     load = Load()
     load.set_filename("testdata_line.txt")
-    print(load.get_filename()) 
+    print(load.get_filename())
     load.set_values()
     print(load.get_values())
-    
-            
+
